var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import '@journeyapps/wa-sqlite';
import * as Comlink from 'comlink';
import { _openDB } from './open-db';
const _self = self;
const DBMap = new Map();
const openDB = (dbFileName) => __awaiter(void 0, void 0, void 0, function* () {
    if (!DBMap.has(dbFileName)) {
        const openPromise = _openDB(dbFileName);
        DBMap.set(dbFileName, openPromise);
        openPromise.catch((error) => {
            // Allow for retries if an error ocurred
            console.error(error);
            DBMap.delete(dbFileName);
        });
    }
    return Comlink.proxy(yield DBMap.get(dbFileName));
});
_self.onconnect = function (event) {
    const port = event.ports[0];
    console.debug('Exposing db on port', port);
    Comlink.expose(openDB, port);
};
addEventListener('beforeunload', (event) => {
    Array.from(DBMap.values()).forEach((dbPromise) => __awaiter(void 0, void 0, void 0, function* () {
        var _a;
        const db = yield dbPromise;
        (_a = db.close) === null || _a === void 0 ? void 0 : _a.call(db);
    }));
});
//# sourceMappingURL=SharedWASQLiteDB.worker.js.map