import { BaseListener, BaseObserver, SyncStatusOptions } from '@journeyapps/powersync-sdk-common';
export declare enum SharedSyncMessageType {
    UPDATE = "sync-status-update"
}
export type SharedSyncStatus = SyncStatusOptions & {
    tabId?: string;
};
export type SharedSyncMessage = {
    type: SharedSyncMessageType;
    payload: SharedSyncStatus;
};
export interface SharedSyncImplementationListener extends BaseListener {
    statusChanged: (status: SharedSyncStatus) => void;
}
export declare class SharedSyncImplementation extends BaseObserver<SharedSyncImplementationListener> {
    protected status: SharedSyncStatus;
    constructor();
    /**
     * Provides a method to get the current state
     * This is needed for a new tab to initialize it's local state
     * before relying on the next broadcast update.
     */
    getState(): SharedSyncStatus;
    updateState(status: SharedSyncStatus): void;
}
